function [R2] = radiusSquaredOfCombination(kernels, mu)
%kernels: kernel matrices (component kernel)
%kernels is cell(1,numKernels), where each cell is a Gram matrix
%mu: weights of component  kernels.

%Build the kernel combination
numKernels = length(kernels);
[numInstances nCol] = size(kernels{1});
K = zeros(numInstances, numInstances);
for i=1:numKernels
     K = K + mu(i)* kernels{i};
end
[R2] = componentRadiusSquared(K);