load proc-ion.dat
X = proc_ion(:,1:34);
Y = proc_ion(:,35);
K1 = kernelmatrix(X,2,1);
K10 = kernelmatrix(X,2,10);
K100 = kernelmatrix(X,2,100);
K_stack=[K1;K10;K100];
C0 = [50 50];
train=1:300;
test=301:351;
nbker=3;
dlmwrite('Kdbg1',[0:351;(1:351)',K1],'\t');
dlmwrite('Kdbg2',[0:351;(1:351)',K10],'\t');
dlmwrite('Kdbg3',[0:351;(1:351)',K100],'\t');
output_dir='code_test_files/';
filename_prefix='debug';
if ~isdir(output_dir),
    mkdir(output_dir);
end
%SKM1=learn_SKM(output_dir,filename_prefix,C0,Y,train,test,'Kdbg1','Kdbg2','Kdbg3');
%SKM=learn_SKM(output_dir,filename_prefix,C0,Y,train,test,'Kdbg1');

fprintf('\n First test passed...!\n');

n=34;
nr_kernels=120;
K=cell(1,nr_kernels);
K_unweighted = zeros(351,351);

arg_feat_vec=cell(1,nr_kernels);
kernel_args = [0.5 5 50 0.1 1 10 0.01 0.05 0.3 3 100 500];
nr_ka = length(kernel_args);
nr_feat_subsets = 4;

for i=1:nr_feat_subsets,
    for j=1:nr_ka,
        arg_feat_vec{(i-1)*nr_ka+j,1} = kernel_args(j);
        arg_feat_vec{(i-1)*nr_ka+j,2} = [floor((n/nr_feat_subsets)*(i-1))+1:floor((n/nr_feat_subsets)*i)];
    end
end

for i=1:nr_kernels,
    K{i}=kernelmatrix(X,2,i);
    K_unweighted = K_unweighted + K{i};
    dlmwrite(['Ktest_' num2str(i)], [0:351;(1:351)',K{i}],'\t');
end
K_unweighted = K_unweighted/nr_kernels;
dlmwrite(['Ktest_unweighted'], [0:351;(1:351)',K_unweighted],'\t');
output_dir='code_test2_files/';
filename_prefix='test2';
mkdir(output_dir);

kernel_list = cell(1,nr_kernels);
for i= 1:nr_kernels
    kernel_list{i} = strcat('Ktest_',int2str(i));
end

% SKM2=learn_SKM(output_dir,filename_prefix,C0,Y,train,test,'Ktest_1','Ktest_2','Ktest_3',...
% 	      'Ktest_4','Ktest_5','Ktest_6','Ktest_7','Ktest_8','Ktest_9','Ktest_10','Ktest_11','Ktest_12','Ktest_13',...
% 	      'Ktest_14','Ktest_15','Ktest_16','Ktest_17','Ktest_18','Ktest_19','Ktest_20','Ktest_21','Ktest_22',...
% 	     'Ktest_23','Ktest_24','Ktest_25','Ktest_26','Ktest_27','Ktest_28','Ktest_29','Ktest_30','Ktest_31',...
%              'Ktest_32','Ktest_33','Ktest_34','Ktest_35','Ktest_36','Ktest_37','Ktest_38','Ktest_39','Ktest_40',...
% 	     'Ktest_41','Ktest_42','Ktest_43','Ktest_44','Ktest_45','Ktest_46','Ktest_47','Ktest_48');

SKM = learn_SKM(output_dir,filename_prefix,C0,Y,train,test,kernel_list);
SKM_unweighted =learn_SKM(output_dir,filename_prefix,C0,Y,train,test,{'Ktest_unweighted'});

fprintf('Second test passed...!\n');

