d = ones(nbker,1);   %%Penalize according to rank?

%% Dekker-Brent parameters
dkb.machine_precision=3e-15;
dkb.maxiter=100;
dkb.bisect_acc=1e-10;

%% MY Regularisation information
regu.value=0.06;          %% Value of the first regularization used
regu.dec_rate=0.3;        %% Multiplicative coefficient to decrease the regularization value
regu.min_reg=1e-7;        %% Minimal value of the regularization parameter beyond which skmreg becomes ill-conditioned
regu.iter_max=20;         %% Maximal number of decreasing regularization values tried before giving up 

%% Precision parameters
acc.tau =7.5e-5;         %% slack to KKT for regularised problem
acc.tau1=5e-5;           %% slack to KKT for unreg pb: "weight stability"
acc.tau2=1e-5;           %% slack to KKT for unreg pb: "alpha slack"
acc.clip_etas = 1e-6;    %% Precision to set a kernel weight (eta) to 0
acc.clip_alphas = 1e-6;  %% Precision to put a point in I_M or I_0. Don't set too small otherwise wrong assignement to sets I_M, I_0, I_C
acc.Dalphas_res = 5e-11; %% Minimal size of alpha step acceptable
acc.Detas_res=1e-3;      %% Precision to assess wether or not the
                         %  weights are changing 
acc.max_nb_alpha_unchanged=2000;  %% Number of consecutive alphas unchanged to assess that no progress is made 
acc.max_nb_etas_unchanged=200;    %% Number of consecutive steps in
                                  % which the weights are changing
                                  % less than acc.Detas_res before
                                  % switching to SVMsmo mode
%counters.nb_cv=10;
%counters.max_nb_reglev=3;
counters.maxiter_per_reg=25000;
%counters.long_iter=10000; %%Number of iterations per regularisation level beyond which deregularization should be slowed down
counters.global=0;

option.store_history=0;  %%Stores the history of the computation
                         %(see documentation)
                         
option.use_svm=1;        %% Option to allow the use of an SVM after freezing the weights when the latter are stable...
