function [new_alphas,etas,Ga]  = linesearch_dual_reg_SKM_brent(Y,train,as,ds,old_alphas,index1,index2,e_constr,f_constr,tol,itmax,epsilon,old_Ga)
% FBGL, Nov 03
%Modified GO, April 05

% Brent's method: 
%        tol = tolerance
%        itmax = maximum number of iterations
%        epsilon = other precision factor for DB (epsilon should be taken at machine precision)
% ---> tol1 = 2*epsilon*abs(b)+0.5*tol;
%        alphas(index1) is the line search variable, bounded by e_constr and f_constr

% a's equal to zero??
global DKDa
global aDKDa
global K_stack


new_alphas = old_alphas;
DKDa_old = DKDa;
aDKDa_old = aDKDa;
% K_stack_inside contains the kernels stacked above each other
n = length(Y);     % number of datapoints
N=size(K_stack,2);
m = size(K_stack,1)/N;   % number of kernels currently non-zeros
s_Y = Y(index1)*Y(index2);


%%% Calculate the initial gradients for the Dekker-Brent algorithm

%edge points
%compute fa=grad_G(alpha=e)
new_alphas(index1) = e_constr;
new_alphas(index2) = old_alphas(index1)*s_Y + old_alphas(index2) - e_constr*s_Y;
delta_alpha = new_alphas(index1) - old_alphas(index1);
for j = 1:m,
    DKDa(index1,j) = DKDa_old(index1,j) ...
        + (double(K_stack((j-1)*N+train(index1),train(index1)))-double(K_stack((j-1)*N+train(index1),train(index2))))*delta_alpha;
    
    DKDa(index2,j) = DKDa_old(index2,j) ...
        + s_Y*(double(K_stack((j-1)*N+train(index1),train(index2)))-double(K_stack((j-1)*N+train(index2),train(index2))))*delta_alpha;
    
    aDKDa(j,1) = aDKDa_old(j,1) + 2*delta_alpha*(DKDa_old(index1,j)-s_Y*DKDa_old(index2,j)) ...
        + (delta_alpha^2)*(double(K_stack((j-1)*N+train(index1),train(index1)))+...
        double(K_stack((j-1)*N+train(index2),train(index2)))-2*double(K_stack((j-1)*N+train(index1),train(index2))));
    
end
% DKDa(index1,:) = DKDa_old(index1,:) + (K_stack_inside(([1:m]-1)*n+index1,index1)-K_stack_inside(([1:m]-1)*n+index1,index2))'*delta_alpha;
% DKDa(index2,:) = DKDa_old(index2,:) + s_Y*(K_stack_inside(([1:m]-1)*n+index1,index2)-K_stack_inside(([1:m]-1)*n+index2,index2))'*delta_alpha;
% aDKDa = aDKDa_old + 2*delta_alpha*(DKDa_old(index1,:)-s_Y*DKDa_old(index2,:))' ...
%         + (delta_alpha^2)*(K_stack_inside(([1:m]-1)*n+index1,index1)+K_stack_inside(([1:m]-1)*n+index2,index2)-2*K_stack_inside(([1:m]-1)*n+index1,index2));
   
 [Ga0,etas] = skmreg(ds,as,aDKDa);        
 Ga = Ga0 - sum(new_alphas);
%grad_Ga = -1 + DKDa*etas;
fa = -1 + s_Y + DKDa(index1,:)*etas -s_Y*DKDa(index2,:)*etas;
Fa=Ga;
% build in some acc?
if fa>0,
    %     for j = 1:m,
    %         for i = 1:n,
    %             if and(i~=index1,i~=index2),
    %                 DKDa(i,j) = DKDa_old(i,j) ...
    %                     + (Y(i)*Y(index1)*K_stack_inside((j-1)*n+i,index1)-s_Y*Y(i)*Y(index2)*K_stack_inside((j-1)*n+i,index2))*delta_alpha;
    %             end
    %         end
    %     end
    for j = 1:m,
        DKDa(:,j) = DKDa_old(:,j) + delta_alpha*Y(index1)*(Y.*(double(K_stack((j-1)*N+train,train(index1)))-...
            double(K_stack((j-1)*N+train,train(index2)))));
    end
    return;
end


%compute fb=grad_G(alpha=f)
new_alphas(index1) = f_constr;
new_alphas(index2) = old_alphas(index1)*s_Y + old_alphas(index2) - f_constr*s_Y;
delta_alpha = new_alphas(index1) - old_alphas(index1);
for j = 1:m,
    DKDa(index1,j) = DKDa_old(index1,j) ...
        + (double(K_stack((j-1)*N+train(index1),train(index1)))-double(K_stack((j-1)*N+train(index1),train(index2))))*delta_alpha;
    DKDa(index2,j) = DKDa_old(index2,j) ...
        + s_Y*(double(K_stack((j-1)*N+train(index1),train(index2)))-double(K_stack((j-1)*N+train(index2),train(index2))))*delta_alpha;
    aDKDa(j,1) = aDKDa_old(j,1) + 2*delta_alpha*(DKDa_old(index1,j)-s_Y*DKDa_old(index2,j)) ...
        + (delta_alpha^2)*(double(K_stack((j-1)*N+train(index1),train(index1)))+double(K_stack((j-1)*N+train(index2),train(index2)))-...
        2*double(K_stack((j-1)*N+train(index1),train(index2))));
end
% DKDa(index1,:) = DKDa_old(index1,:) + (K_stack_inside(([1:m]-1)*n+index1,index1)-K_stack_inside(([1:m]-1)*n+index1,index2))'*delta_alpha;
% DKDa(index2,:) = DKDa_old(index2,:) + s_Y*(K_stack_inside(([1:m]-1)*n+index1,index2)-K_stack_inside(([1:m]-1)*n+index2,index2))'*delta_alpha;
% aDKDa = aDKDa_old + 2*delta_alpha*(DKDa_old(index1,:)-s_Y*DKDa_old(index2,:))' ...
%         + (delta_alpha^2)*(K_stack_inside(([1:m]-1)*n+index1,index1)+K_stack_inside(([1:m]-1)*n+index2,index2)-2*K_stack_inside(([1:m]-1)*n+index1,index2));  
 [Ga0,etas] = skmreg(ds,as,aDKDa);        
 Ga = Ga0 - sum(new_alphas);
%grad_Ga = -1 + DKDa*etas;
%grad_Ga = 0;
fb = -1 + s_Y + DKDa(index1,:)*etas -s_Y*DKDa(index2,:)*etas;
Fb=Ga;
if fb<0,
    %     for j = 1:m,
    %         for i = 1:n,
    %             if and(i~=index1,i~=index2),
    %                 DKDa(i,j) = DKDa_old(i,j) ...
    %                     + (Y(i)*Y(index1)*K_stack_inside((j-1)*n+i,index1)-s_Y*Y(i)*Y(index2)*K_stack_inside((j-1)*n+i,index2))*delta_alpha;
    %             end
    %         end
    %     end
    for j = 1:m,
        DKDa(:,j) = DKDa_old(:,j) + delta_alpha*Y(index1)*(Y.*(double(K_stack((j-1)*N+train,train(index1)))-...
            double(K_stack((j-1)*N+train,train(index2)))));
    end
    return;
end


% Brent's method
b0=old_alphas(index1);
a=e_constr;   %% a is last best guess for the root a_{t+1}=b_{t} 
b=f_constr;   %% b is current best guess for the root
c=f_constr;   %% b is between a and c

if or(and(fa>0,fb>0),and(fa<0,fb<0)),
    error('Root must be bracketed in Brents method');
end
fc=fb;
Fc=Fb;
for iter = 1:itmax,
    %% Since b is current best guess and b is to become the next a, set c
    %% to be either c or a such that we bracket the root with [b,c] or [c,b]
    if or(and(fb>0,fc>0),and(fb<0,fc<0)),
        c=a;
        fc=fa;
        Fc=Fa;
        d=b-a;
        e=d;
        if (min(Fb,Fc)>=old_Ga+tol & ~(b0>=min(c,b) & b0<=max(c,b))),
            disp('Old root not bracketed');
            keyboard;
        end 
    end
    %% If c appears to be a current better guess than b then exchange them
    %% and set a to be b, which at this point has to be the second best
    %% guess
    if abs(fc)<abs(fb),
        a=b;
        b=c;
        c=a;
        fa=fb; Fa=Fb;
        fb=fc; Fb=Fc;
        fc=fa; Fc=Fa;
    end
    tol1 = 2*epsilon*abs(b)+0.5*tol;
    xm = 0.5*(c-b);   %% xm is such that b+xm is (b+c)/2 in case we bisect...
    %% If we have obtained enough precision then b becomes the new alpha_1
    %% and (???) recalculate aDKDa
    if and(or(abs(xm)<=tol1,abs(fb)<tol),Fb<=old_Ga+tol),   %% discrepancy with Fortran code found:
     %if or(abs(xm)<=tol1,abs(fb)==0),
        new_alphas(index1) = b;
        new_alphas(index2) = old_alphas(index1)*s_Y + old_alphas(index2) - b*s_Y;
        delta_alpha = new_alphas(index1) - old_alphas(index1);
        for j = 1:m,
            DKDa(index1,j) = DKDa_old(index1,j) ...
                + (double(K_stack((j-1)*N+train(index1),train(index1)))-double(K_stack((j-1)*N+train(index1),train(index2))))*delta_alpha;
            DKDa(index2,j) = DKDa_old(index2,j) ...
                + s_Y*(double(K_stack((j-1)*N+train(index1),train(index2)))-double(K_stack((j-1)*N+train(index2),train(index2))))*delta_alpha;
            aDKDa(j,1) = aDKDa_old(j,1) + 2*delta_alpha*(DKDa_old(index1,j)-s_Y*DKDa_old(index2,j)) ...
                + (delta_alpha^2)*(double(K_stack((j-1)*N+train(index1),train(index1)))+double(K_stack((j-1)*N+train(index2),train(index2)))-...
                2*double(K_stack((j-1)*N+train(index1),train(index2))));
        end
        %fprintf('%10.5g \t %10.5g \t %10.5g \t %10.5g \t %10.5g \n',aDKDa);
        if (any(aDKDa<0)),
        disp('aDKDa<0: matrix not psd');
        keyboard;
        end
        [Ga0,etas] = skmreg(ds,as,aDKDa);        
        Ga = Ga0 - sum(new_alphas);   %% Final objective
        %fprintf('Ga=%.10g\n',Ga);
  
        for j = 1:m,
            DKDa(:,j) = DKDa_old(:,j) + delta_alpha*Y(index1)*(Y.*(double(K_stack((j-1)*N+train,train(index1)))-...
                double(K_stack((j-1)*N+train,train(index2)))));
        end
        return  %% Exits the program here
    end
    %% If the size of the current bracket is larger than the tolerance and
    %% assuming that at the end of the previous iteration the bracket had turned into
    %% [a_{t-1},b_{t-1}] or [b_{t-1},a_{t-1}], if b is a better guess at the zero than a then go
    %% ahead and do an interpolation, if we realize on the contrary that
    %% actually b is not a better guess at the zero than a then bisect
    if and(abs(e) >= tol1,abs(fa)>abs(fb)),
        s = fb/fa;
        if a==c,
            p = 2*xm*s;
            q = 1-s;
        else
            q = fa/fc;
            r = fb/fc;
            p = s*(2*xm*q*(q-r)-(b-a)*(r-1));
            q = (q-1)*(r-1)*(s-1);
        end
        if p>0,
            q = -q;
        end
        p = abs(p);
        min1 = 3*xm*q-abs(tol1*q);
        min2 = abs(e*q);
        if 2*p < min([min1 min2]),  %% Checking if the guess of interpolation is within reasonable bounds otherwise bisect
            e = d;
            d = p/q;
        else
            d = xm;
            e = d;
        end
    else
        d = xm;
        e = d;
    end
    a = b;  %% a becomes a record of the current to become previous b
    fa = fb;
    Fa = Fb;  
    %% Update b
    if abs(d)>tol1,
        b = b+d;
    else
        if xm>=0,
            incr = abs(tol1);
        else
            incr = -abs(tol1);
        end
        b = b+incr;
    end
    new_alphas(index1) = b;
    new_alphas(index2) = old_alphas(index1)*s_Y + old_alphas(index2) - b*s_Y;
    delta_alpha = new_alphas(index1) - old_alphas(index1);
    
    %% We need to update grad(A)=etas'*DKDa-1
    for j = 1:m,
        DKDa(index1,j) = DKDa_old(index1,j) ...
            + (double(K_stack((j-1)*N+train(index1),train(index1)))-double(K_stack((j-1)*N+train(index1),train(index2))))*delta_alpha;
        DKDa(index2,j) = DKDa_old(index2,j) ...
            + s_Y*(double(K_stack((j-1)*N+train(index1),train(index2)))-double(K_stack((j-1)*N+train(index2),train(index2))))*delta_alpha;
        %%% Is it really necessary to update aDKDa at this point ?? Well:
        %%% yes if you want to calculate Ga no if not
        aDKDa(j,1) = aDKDa_old(j,1) + 2*delta_alpha*(DKDa_old(index1,j)-s_Y*DKDa_old(index2,j)) ...
            + (delta_alpha^2)*(double(K_stack((j-1)*N+train(index1),train(index1)))+double(K_stack((j-1)*N+train(index2),train(index2)))-...
            2*double(K_stack((j-1)*N+train(index1),train(index2))));
    end 
        %fprintf('%10.5g \t %10.5g \t %10.5g \t %10.5g \t %10.5g \n',aDKDa);
        if (any(aDKDa<0)),
        disp('aDKDa<0 : Matrix non psd');
        keyboard;
        end

        [Ga0,etas] = skmreg(ds,as,aDKDa);
        Ga = Ga0 - sum(new_alphas);        
    % use previous eta's to speed up...<- Gert's idea...Not in application
    % now
    
    fb = -1 + s_Y + DKDa(index1,:)*etas -s_Y*DKDa(index2,:)*etas;
    Fb=Ga;
    if ~(Fb<=Fa+tol | Fb<=Fc+tol);
        error('Non dec Dk-B');
    end
end
if ~(Fb<=old_Ga+tol),
      new_alphas(index1) = old_alphas(index1);
        new_alphas(index2) = old_alphas(index2);
        delta_alpha = new_alphas(index1) - old_alphas(index1);
        for j = 1:m,
            DKDa(index1,j) = DKDa_old(index1,j) ...
                + (double(K_stack((j-1)*N+train(index1),train(index1)))-double(K_stack((j-1)*N+train(index1),train(index2))))*delta_alpha;
            DKDa(index2,j) = DKDa_old(index2,j) ...
                + s_Y*(double(K_stack((j-1)*N+train(index1),train(index2)))-double(K_stack((j-1)*N+train(index2),train(index2))))*delta_alpha;
            aDKDa(j,1) = aDKDa_old(j,1) + 2*delta_alpha*(DKDa_old(index1,j)-s_Y*DKDa_old(index2,j)) ...
                + (delta_alpha^2)*(double(K_stack((j-1)*N+train(index1),train(index1)))+double(K_stack((j-1)*N+train(index2),train(index2)))-...
                2*double(K_stack((j-1)*N+train(index1),train(index2))));
        end
        %fprintf('%10.5g \t %10.5g \t %10.5g \t %10.5g \t %10.5g \n',aDKDa);
        if (any(aDKDa<0)),
        disp('aDKDa<0: matrix not psd');
        keyboard;
        end
        [Ga0,etas] = skmreg(ds,as,aDKDa);        
        Ga = Ga0 - sum(new_alphas);   %% Final objective
        if (Ga-old_Ga)>tol,
            error('Recalculation of objective gives different result');
        end
disp('Using new pair led to deterioration: ignoring the iteration');
keyboard;
end
disp('max number of iterations reached for the Dekker-Brent line search');

