%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%SMO loop inside a loop to decrease the parameter regularisation  %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




finish_reg_step=0;
only_I_M=0;
counter=0;
refract=refract0;
I.I_M = and(old_alphas>=acc.clip_alphas,old_alphas<=C-acc.clip_alphas);
I.I_0min = and(old_alphas<acc.clip_alphas,Y==-1);
I.I_0plus = and(old_alphas<acc.clip_alphas,Y==1);
I.I_Cmin = and(old_alphas>C-acc.clip_alphas,Y==-1);
I.I_Cplus = and(old_alphas>C-acc.clip_alphas,Y==1);

acc.max_nb_alpha_unchanged=100;
all_alpha_unchanged=0;
reg_iter=1;

while(~unreg_optimal & reg_iter<=regu.iter_max & (regu.value>regu.min_reg | option.svm));
    optimal=0;
    over_maxiter=0;
    %fprintf('\n Solving at regularization level a=%g\n',regu.value);
    %fprintf('%-9s%-20s%-16s%-16s%-16s%-16s \n','COUNT','OBJ','TAU','EPS1','EPS2','ALPHA STEP');
    nb_etas_unchanged=0;
    while(~finish_reg_step)
        if (only_I_M)
            %% Examine only I_M
            finish_I_M=0;
            while(~finish_I_M);
                alpha_unchanged=0;
                etas_unchanged=0;
                eps_i_unchanged=0;

                %% Find best pair or detect that optimality is reached in I_M
                [index1,index2,optimal_I_M,tau_here] = find_best_pair(Y,etas,a,d,old_alphas,only_I_M,-1,acc.clip_alphas,acc.tau);
                if ~optimal_I_M,
                    skm_smo_step;
                end
                if ~option.svm & option.use_svm,
                    if etas_unchanged,
                        nb_etas_unchanged=nb_etas_unchanged+1;
                    else
                        nb_etas_unchanged=0;
                    end
                    switch_to_svm=nb_etas_unchanged> acc.max_nb_etas_unchanged;
                end
                %%SMO decisions
                finish_I_M=optimal_I_M |alpha_unchanged| (switch_to_svm & ~option.svm) ...
                    | eps_i_unchanged | over_maxiter;
                finish_reg_step=over_maxiter | nb_etas_unchanged> ...
                    acc.max_nb_etas_unchanged ;
            end
            only_I_M=0;
        else
            %% Examine all
            nb_alpha_unchanged=0;
            tr_pt = 1;
            while (tr_pt <= n) & ~(over_maxiter | all_alpha_unchanged ...
                    | nb_etas_unchanged> ...
                    acc.max_nb_etas_unchanged);
                alpha_unchanged=0;
                eps_i_unchanged=0;
                [index1,index2,optimal,tau_here] = find_best_pair(Y,etas,a,d,old_alphas,only_I_M,tr_pt,acc.clip_alphas,acc.tau);
                if ~optimal,
                    skm_smo_step;
                    if alpha_unchanged,
                        nb_alpha_unchanged=nb_alpha_unchanged+1;
                    else
                        nb_alpha_unchanged=0;
                    end
                    all_alpha_unchanged=nb_alpha_unchanged> ...
                        acc.max_nb_alpha_unchanged;
                    if ~option.svm & option.use_svm,
                        if etas_unchanged,
                            nb_etas_unchanged=nb_etas_unchanged+1;
                        else
                            nb_etas_unchanged=0;
                        end
                        switch_to_svm=nb_etas_unchanged>acc.max_nb_etas_unchanged;
                    end
                end

                tr_pt=tr_pt+1;
            end
            %%SMO decisions
            finish_reg_step=optimal |all_alpha_unchanged |(switch_to_svm & ~option.svm)|eps_i_unchanged | over_maxiter;
            only_I_M=1;
        end
    end


    %%% Assess the current status
    if counter>0,
        if option.store_history,
            %fprintf(['%5d - %-20.14g %-15.5g %-15.5g %-15.5g %-15.5g' repmat('%-7.4f',1,length(etas_tilde_here)) '\n'],counters.global,obj_curr,tau_here,eps1_here,eps2_here,dalphas,etas_tilde_here);
        else
            %fprintf(['%5d -%20s %-15.5g %-15.5g %-15.5g %-15.5g' repmat('%-7.4f',1,length(etas_tilde_here)) '\n'],counters.global,'*',tau_here,eps1_here,eps2_here,dalphas,etas_tilde_here);
        end

        unreg_optimal=(eps1_here<acc.tau1 & eps2_here<acc.tau2);
        if unreg_optimal,
           % fprintf('OPTIMAL!\n');
        elseif optimal,
            %fprintf('reg optimal at a=%g\n',regu.value);
        elseif over_maxiter,
            %fprintf('over maximal number of iterations\n')
        %elseif (eps1_here==0 & option.use_svm),
        %    fprintf('Since eps1_here=0: using SVM\n');
        elseif all_alpha_unchanged,
            %fprintf('Progress in alpha is too slow\n');
        elseif option.svm & reg_iter==1,
            %fprintf('SVM smo completed\n');
            keyboard;
        elseif switch_to_svm,
            %fprintf('Weights not changing: switching to plain SVM SMO\n');
        else
           % fprintf('unable to improve the current solution\n')
        end
    end

    %fprintf('Discrepancy in aDKDa:')
    Kzoo=reshape(K_stack(:,train)*(new_alphas.*Y),N,length(aDKDa));
    DKDa=repmat(Y,1,length(aDKDa)).*Kzoo(train,:);
    aDKDa=(new_alphas'*DKDa)';
    if option.svm,
        Ga0=aDKDa;
        etas=1;
    else
        [Ga0,etas] = skmreg(d,a,aDKDa);
    end

    %%  SVM step:
    %% if the weights seem stable or there is not progress or the algorithm
    %% is too slow, do an svm step
    if ~option.svm & option.use_svm & switch_to_svm,
        nbker=length(etas);
        Ksvm=zeros(N);
        for j=1:nbker,
            if etas_tilde_here(j)>0,
                Ksvm=Ksvm+etas_tilde_here(j)*K_stack(N*(j-1)+(1:N),1:N);
            end
        end
        SKM_saved.etas_tilde=etas_tilde_here;
        SKM_saved.K_stack=K_stack;
        K_stack=Ksvm;
        m=1;
        regu.value=0;
        regu.iter_max=1;
        reg_iter=0;
        DKDa=Y.*(K_stack(train',train)*(Y.*new_alphas));
        aDKDa=(new_alphas'*DKDa)';
        update_all_Is(new_alphas,1:n,acc.clip_alphas,Y,C);

        etas=1;
        etas_tilde_here=1;
        a=0;
        d=1;
        option.svm=1;
        switched_to_SVM=1;
    end

    %% After an SVM run (or if counter==0) the parameters have to be
    %% recalculated
    if counter==0, %| (option.use_svm & (over_maxiter | all_alpha_unchanged | eps1_here==0)),
        if counter==0,
            %% If the initial solution is optimal it is detected by find_best_pair
            %% (line 50) and no other parameter has been updated... in particular
            %% counter==0. so we have to update the parameters
           % fprintf('Solution is at least reg optimal at start\n');
            if counters.global==0;
                new_alphas=SKM0.alphas;
                old_alphas=new_alphas;
            end
        end

        if option.svm,
            Ga0=aDKDa;
            etas=1;
        else
            [Ga0,etas] = skmreg(d,a,aDKDa);
        end

        dalphas=norm(new_alphas-old_alphas);
        etas_tilde_here = etas./(1-((a.^2).*etas));
        eps1_here = 0.5*(max(aDKDa(find(etas>acc.clip_etas),1)) - min(aDKDa(find(etas>acc.clip_etas),1)));
        I_min = I.I_M| I.I_0plus| I.I_Cmin;  %% for these b_tilde<=b at the optimum
        I_max = I.I_M| I.I_0min| I.I_Cplus;  %% for these b_tilde>=b at the optimum
        g2 = -1 + DKDa*etas_tilde_here;
        yg2 = Y.*g2;
        [bl2,i_low] = min(yg2(I_min));
        [bu2,i_up] = max(yg2(I_max));
        eps2_here = (bu2 - bl2)/2;
        if eps2_here<0,
           % fprintf('The constraint on the norm is too hard:\n all the points are on the wrong side of the margin');
            eps2_here=0;
        end

        if option.store_history,
            bias=-(bl2+bu2)/2;
            obj_curr=0.5*etas_tilde_here'*aDKDa-sum(new_alphas);
            obj_ub_curr=0.5*max(aDKDa)-sum(new_alphas);
            if obj_curr>obj_ub_curr+1e-10,
                error('obj_curr>obj_ub_curr');
            end

            eps2s = [eps2s eps2_here];

            kkt=-g2-Y*bias;
            obj_lb_curr=-0.5*max(aDKDa)-C'*max(kkt,0);
            cost_curr=sum(max(kkt,0));
            step_loss_curr=mean(1-sign(1-kkt))/2;

            obj=[obj obj_curr];
            obj_lb=[obj_lb obj_lb_curr];
            obj_ub=[obj_ub obj_ub_curr];
            step_loss=[step_loss step_loss_curr];
            cost=[cost cost_curr];
        end


        if option.store_history,
            %fprintf(['%5d - %-20.14g %-15.5g %-15.5g %-15.5g %-15.5g' repmat('%-7.4f',1,length(etas_tilde_here)) '\n'],counters.global,obj_curr,tau_here,eps1_here,eps2_here,dalphas,etas_tilde_here);
        else
            %fprintf(['%5d -%20s %-15.5g %-15.5g %-15.5g %-15.5g' repmat('%-7.4f',1,length(etas_tilde_here)) '\n'],counters.global,'*',tau_here,eps1_here,eps2_here,dalphas,etas_tilde_here);
        end

        unreg_optimal=(eps1_here<acc.tau1 & eps2_here<acc.tau2);
        if unreg_optimal,
          %  fprintf('OPTIMAL!\n');
        elseif optimal,
           % fprintf('reg optimal at a=%g\n',regu.value);
        elseif over_maxiter,
          %  fprintf('over maximal number of iterations\n')
        elseif all_alpha_unchanged,
          %  fprintf('Progress in alpha is too slow\n');
        elseif (eps1_here==0 & option.use_svm),
          %  fprintf('eps1_here=0\n');
        else
          %  fprintf('unable to improve the current solution\n')
        end
    end

    regu.value=regu.value*regu.dec_rate;
    a=regu.value*ones(m,1);
    finish_reg_step=0;
    %optimal=0;
    only_I_M=0;
    all_alpha_unchanged=0;
    nb_alpha_unchanged=0;
    counter=0;
    refract=refract0;
    if option.svm,
        Ga0=aDKDa;
        etas=1;
    else
        [Ga0,etas] = skmreg(d,a,aDKDa);
    end
    Ga=Ga0-sum(new_alphas);

    reg_iter=reg_iter+1;
end
if ~(reg_iter<regu.iter_max) & ~option.svm
    %fprintf('Maximal number of decreases of the regularization reached\n');
elseif ~(regu.value>regu.min_reg),
    %fprintf('The smallest possible value of the regularization has been reached\n');
end
%fprintf('DONE!\n')
%keyboard;
