
if option.svm,
    [new_alphas Ga]=svmsmo_update(Y,C,train,old_alphas,index1,index2,Ga);
    etas_unchanged=1;
else

    % alpha_index1 is the linesearch variable
    % boundaries on alpha
    [e,f] = boundaries(Y(index1), Y(index2), old_alphas(index1), old_alphas(index2), C(index1),C(index2));
    % optimize chosen pair of alpha's

old_etas=etas;
    [new_alphas, etas, Ga] = linesearch_dual_reg_SKM_brent...
        (Y,train,a,d,old_alphas,index1,index2,e,f,dkb.bisect_acc,dkb.maxiter,dkb.machine_precision,Ga);
detas=norm(old_etas-etas);
etas_unchanged=detas<acc.Detas_res;

end

dalphas=(norm(new_alphas-old_alphas));
alpha_unchanged=dalphas<acc.Dalphas_res;
old_alphas = new_alphas;
etas_tilde_here = etas./(1-((a.^2).*etas));
etas_tilde_here=etas_tilde_here/sum(etas_tilde_here);
update_Is(new_alphas,index1,index2,acc.clip_alphas,Y,C);

%% Update Control Variables
%Gas = [Gas Ga];
%taus = [taus max(tau_here,0)];
eps1_here = 0.5*(max(aDKDa(find(etas>acc.clip_etas),1)) - min(aDKDa(find(etas>acc.clip_etas),1)));
%eps1s = [eps1s eps1_here];
I_min = I.I_M| I.I_0plus| I.I_Cmin;  %% for these b_tilde<=b at the optimum
I_max = I.I_M| I.I_0min| I.I_Cplus;  %% for these b_tilde>=b at the optimum
g2 = -1 + DKDa*etas_tilde_here;
yg2 = Y.*g2;
[bl2,i_low] = min(yg2(I_min));
[bu2,i_up] = max(yg2(I_max));
eps2_here = (bu2 - bl2)/2;
if eps2_here<0,
    eps2_here=0;
    fprintf('The constraint on the the norm is too heavy:\n all the points are within the margin');
end
%eps2s = [eps2s eps2_here];


if option.store_history,
  bias=-(bl2+bu2)/2;
  obj_curr=0.5*etas_tilde_here'*aDKDa-sum(new_alphas);
  obj_ub_curr=0.5*max(aDKDa)-sum(new_alphas);
  if obj_curr>obj_ub_curr+1e-8,
      warning('obj_curr>obj_ub_curr');
  end
  Gas = [Gas Ga];  
  taus = [taus max(tau_here,0)];
  eps1s = [eps1s eps1_here];
  eps2s = [eps2s eps2_here];   
  kkt=-g2-Y*bias;
  obj_lb_curr=-0.5*max(aDKDa)-C'*max(kkt,0);
  cost_curr=sum(max(kkt,0));
  step_loss_curr=mean(1-sign(1-kkt))/2;

 if length(Gas)>1,
       obj=[obj obj_curr];
       obj_ub=[obj_ub obj_ub_curr];
       obj_lb=[obj_lb obj_lb_curr];
       step_loss=[step_loss step_loss_curr];
       cost=[cost cost_curr];

       if (Gas(end)>Gas(end-1)+0.0000001) & (counter>0),
           %warning('Reg Objective increasing!\n');
           %keyboard;
       end
   end


       I_M_evol=[I_M_evol only_I_M];
       %weights_evol(orig_indices,counters.global) = etas_tilde_here;
       a_evol=[a_evol a(1)];
end

if 0,
    if refract==0,
        %% Check if eps1 and eps2 are still changing
        eps_i_unchanged=is_stable_SKM_sol(eps1s(end-nb_steps:end),eps2s(end-nb_steps:end));

        %% Measure amplitude of the oscillations of tau around its mean value
        %oscil_tau=meas_oscil(log(taus(end-nb_steps2:end)));
        %oscil_tau_evol=[oscil_tau_evol oscil_tau];
        %oscil_tau_local_evol=[oscil_tau_local_evol oscil_tau];
    else
        refract=refract-1;
        %oscil_tau_evol=[oscil_tau_evol 0];
        %oscil_tau_local_evol=[oscil_tau_local_evol 0];
    end
end

%%Update Counters
counter = counter + 1;
counters.global = counters.global + 1;
over_maxiter=counter>counters.maxiter_per_reg;

if mod(counter,100)==1,
  if option.store_history,
    if m<7
      %fprintf(['%5d - %-20.14g %-15.5g %-15.5g %-15.5g %-15.5g' repmat('%-7.2f',1,length(etas_tilde_here)) '\n'],counters.global,obj_curr,tau_here,eps1_here,eps2_here,dalphas,etas_tilde_here);
    else
      %fprintf(['%5d - %-20.14g %-15.5g %-15.5g %-15.5g %-15.5g\n'],counters.global,obj_curr,tau_here,eps1_here,eps2_here,dalpha);
    end
    
  else
    if m<7,
      %fprintf(['%5d -%20s %-15.5g %-15.5g %-15.5g %-15.5g' repmat('%-7.2f',1,length(etas_tilde_here)) '\n'],counters.global,'*',tau_here,eps1_here,eps2_here,dalphas,etas_tilde_here);
    else
      %fprintf(['%5d -%20s %-15.5g %-15.5g %-15.5g %-15.5g\n'],counters.global,'*',tau_here,eps1_here,eps2_here,dalphas);
    end
  end
  
end
