function [Ga0,etas]=skmreg(ds,as,aDKDa);
%This code assumes that ds==ones(nbker,1);
%and as is constant
% Ga0=Ga+sum(alphas)
m=length(aDKDa);
a2=as(1)^2;
if all(aDKDa==0),
  Ga0=0;
  etas=1./(1+a2)*ones(m,1);
  return;
end

gammas=(1./ds).*sqrt(aDKDa);
[gammas0,bb]=sort(gammas);
ds=ds(bb); as=as(bb);
u=0; v=0;
k=m;
while ( k>=1 ) & ( -(u+a2)*gammas0(k)+v <0 ), 
    u = u + 1;
    v = v + gammas0(k);
    k = k - 1;
end
k = k + 1;

gamma_ast=v/(u+a2);
mu_ast=zeros(m,1);
ind=bb(k:end);
mu_ast(ind)=gammas0(ind);
etas = zeros(m,1);
nz=find(mu_ast>0);
b_ast=bb(m);

%if k<m,
%    if ~all(aDKDa==0) & any(gammas(nz,1)-gamma_ast<1e-20),
%        error('SKMsmo:skmreg:toosmall','The regularization is too small for machine precision');
%    end
%    %etas(nz,1) = (1./(as(nz,1).^2)).*(1-(gamma_ast./gammas(nz,1)));
%    etas(nz,1) = (gammas(nz,1)-gamma_ast)./(as(nz,1).^2.*gammas(nz,1));
%else
%    inv_c=as(m).^2/ds(m).^2;
%    etas(nz,1)=(1./ds(m).^2+(1-(gammas0(m)./gammas(nz,1)))./as(m).^2)./((1+inv_c));
%    gamma_ast=gammas0(m)./(1+inv_c);
%end


%for i=nz',
%      etas(i,1)=(ds(1)^2*sum([(m-k+1)*gammas(i); (-gammas0(k:m))])+a2*gammas(i))./(((m-k+1)*ds(1)^2+a2)*gammas(i)*a2);
%end

for i=nz',
if k==m,
  if i==b_ast,
    etas(i,1)=1./(1+a2);
  else  
    etas(i,1)=(gammas(i)-gammas(b_ast))/(a2*(1+a2)*gammas(i))+1./(1+a2);
  end
else %%k<m
  etas(i,1)=sum(gammas(i)-gammas0(k:m))/(a2*(m-k+1+a2)*gammas(i))+1./(m-k+1+a2);
end
end

gamma_ast=sum(gammas0(k:m))./((m-k+1)+a2);

if any(etas<0), 
    error('Some etas are negative')
end
if all(etas==0),
    error('All etas are zero')
end


Ga0 = 0.5*gamma_ast^2 + 0.5*a2*sum((etas.*gammas).^2);
