data = dlmread('ionosphere.data');
[numInstances nCol] = size(data);

Y = data(1:numInstances, end);
X = data(1:numInstances, 1:end-1);

[numInstances numFeatures] = size(X);

%X = normalizemeanstd(X);
for i = 1: numInstances
        s = sqrt(X(i,1:end) * X(i,1:end)');
        X(i,1:end) = X(i,1:end)/s;
end
numKernels = numFeatures;

% Create linear kernels
K = cell(1,numFeatures);
for i = 1:numFeatures
	K{i} = X(1:end,i)*X(1:end,i)';
	
end

numTrain = floor(numInstances*7/10);
numTest  =  numInstances - numTrain;
C = 0.001;

Ktrain=cell(1,numKernels);
for k = 1: numKernels
    Ktrain{k} = K{k}(1:numTrain, 1:numTrain);
end

% Begin R-SVM 
% Compute component radius squared
radiusSquared = zeros(1,numKernels);
for k = 1:numKernels
    radiusSquared(1,k) = radiusSquaredForRM_SVM(X(1:numTrain, k));
    if(radiusSquared(1,k) <= 0.00001) 
        radiusSquared(1,k)= 0;
    end
end
[mu L1 alpha Alpsup w0 pos ] = twoStepAlgSoft(Ktrain, radiusSquared, C, Y(1:numTrain));
 
KOptimal = zeros(numInstances, numInstances );

 for k=1:numKernels,
     KOptimal = KOptimal + mu(k) * K{i};
 end
 temp = 1:numTrain;
Ktest = KOptimal((numTrain+1):end, temp(pos));
ypred = Ktest * Alpsup + w0;

accuracy = mean(sign(ypred)==Y(numTrain+1:end));     
error = 1-accuracy;

% End  R-SVM

% test with linear SVM
delta = eye(numInstances, numInstances);
t = X*X' + delta/C;
[w,bias,pos,alpha2,obj] = svmLargeScaleL2Class(Y(1:numTrain),t(1:numTrain, 1:numTrain));
tmp = 1:numTrain;
Ktest = t(tmp(pos),numTrain+1:end);
y_predict = Ktest' * w + bias;
accuracy_SVM = mean(sign(y_predict)==Y(numTrain+1:end));
% end linear SVM

